# Firebase

Firebase example project for PV239/Flutter purposes.

## Getting Started

### Firebase:

- NOSQL db,
- serverless architecture, computation logic is transferred into application,
- [firebase functions](https://firebase.google.com/docs/functions) are available for more demanding computations,
- [**cloud firestore**](https://firebase.google.com/docs/firestore) vs [realtime database](https://firebase.google.com/docs/database)
  - [comparison](https://firebase.google.com/docs/firestore/rtdb-vs-firestore) by google
- db security done using [rules](https://firebase.google.com/docs/firestore/security/get-started),
- firebase configuration and initialization in app:
  - [Android](https://firebase.google.com/docs/android/setup)
  - [iOS](https://firebase.google.com/docs/ios/setup)
- [data model](https://firebase.google.com/docs/firestore/data-model),
  - careful with wrong document data format

## Practical

Firebase and Flutter -> [**FlutterFire**](https://firebase.flutter.dev/)

### Pub.dev:

- [cloud_firestore](https://pub.dev/packages/cloud_firestore),
- [firebase_auth](https://pub.dev/packages/firebase_auth),

### Tasks and tutorials:

- [FlutterFire Docs](https://firebase.flutter.dev/docs/overview),
- [add](https://firebase.flutter.dev/docs/firestore/usage#adding-documents) a new document,
- [observe](https://firebase.flutter.dev/docs/firestore/usage#realtime-changes) a collection using Stream and StreamBuilder,
- JSON [serialization](https://firebase.flutter.dev/docs/firestore-odm/code-generation),
- auth using [Google](https://firebase.flutter.dev/docs/auth/social#google)

&nbsp;

&nbsp;

&nbsp;

&nbsp;

#### Default flutter ReadMe.md

A few resources to get you started if this is your first Flutter project:

- [Lab: Write your first Flutter app](https://flutter.dev/docs/get-started/codelab)
- [Cookbook: Useful Flutter samples](https://flutter.dev/docs/cookbook)

For help getting started with Flutter, view our
[online documentation](https://flutter.dev/docs), which offers tutorials,
samples, guidance on mobile development, and a full API reference.
