import 'package:cloud_firestore/cloud_firestore.dart';
import 'package:firebase_auth/firebase_auth.dart';
import 'package:firebase_storage/firebase_storage.dart';

class FirebaseHandler {

  Stream<QuerySnapshot<Map<String, dynamic>>> getFirebaseCollectionByNameUserId(String name, String userCredential){
    return FirebaseFirestore.instance.collection(name)
        .where('userId', isEqualTo:  userCredential)
        .snapshots();
  }

  Stream<QuerySnapshot<Map<String, dynamic>>> getFirebaseCollectionByNameOwningId(String name, String userCredential){
    return FirebaseFirestore.instance.collection(name)
        .where('owningId', isEqualTo:  userCredential)
        .snapshots();
  }

  Stream<QuerySnapshot<Map<String, dynamic>>> getFirebaseCollectionByNameUserIdFolderId(String name, String userCredential, String folderId){
    return FirebaseFirestore.instance.collection(name)
        .where('userId', isEqualTo:  userCredential)
        .where('folderId', isEqualTo: folderId)
        .snapshots();
  }

  FirebaseStorage getFirebaseStorage(){
    return FirebaseStorage.instance;
  }

  Future<UserCredential> signIn(AuthCredential credential){
    return FirebaseAuth.instance.signInWithCredential(credential);
  }

  Future<void> signOut(){
    return  FirebaseAuth.instance.signOut();
  }
}
