import 'package:flutter/material.dart';
import 'models/item_model.dart';

class ItemPage extends StatelessWidget {

  final ItemModel _item;

  const ItemPage({Key? key, required ItemModel item})
      : _item = item,
        super(key: key);

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      appBar: AppBar(
        title: Text(
          _item.name,
        ),
      ),
      body: Padding(
        padding: const EdgeInsets.all(20.0),
        child: Column(
          mainAxisSize: MainAxisSize.max,
          crossAxisAlignment: CrossAxisAlignment.stretch,
          children: [
            Expanded(
              flex: 6,
              child: Image.network(
                _item.imageUrl,
                fit: BoxFit.contain,
              ),
            ),
          Expanded(
            flex: 4,
            child: ListTile(
              title: Padding(
                padding: const EdgeInsets.fromLTRB(0, 10, 0, 10),
                child: Text(
                  _item.name,
                  style: const TextStyle(
                    fontSize: 20.0,
                  ),
                ),
              ),
              subtitle: Text(
                _item.note,
                style: const TextStyle(
                  fontSize: 18.0,
                ),
              ),
              contentPadding: const EdgeInsets.symmetric(
                vertical: 0.0, horizontal: 0.0
              ),
            ),
          ),
        ], ),
      ),
    );
  }
}
