import 'package:cloud_firestore/cloud_firestore.dart';

import 'folder_model.dart';

class FolderModelFirebase {

  static final CollectionReference _foldersRef = FirebaseFirestore.instance.collection('folders');

  static Future<void> storeFolder(FolderModel folder) async {
    String docId = '';
    await _foldersRef
        .where('id', isEqualTo: folder.id)
        .get()
        .then((QuerySnapshot value) {docId = value.docs.first.id;})
        .catchError((error) {});

    if (docId.isEmpty) {
      return _foldersRef
          .add(folder.toJson())
          .then((value) => print('Folder Added'))
          .catchError((error) => print('Failed to add folder: $error'));
    }

    return _foldersRef
        .doc(docId)
        .update(folder.toJson())
        .then((value) => print('Folder ${folder.name} -- $docId updated'))
        .catchError((error) => print('Failed to update folder ${folder.name} -- $docId: $error'));
  }

  static Future<void> deleteFolder(FolderModel folder) async {
    String docId = '';
    await _foldersRef
        .where('id', isEqualTo: folder.id)
        .get()
        .then((QuerySnapshot value) {docId = value.docs.first.id;})
        .catchError((error) {});

    return _foldersRef
        .doc(docId)
        .delete()
        .then((value) => print('Folder ${folder.name} -- ${folder.id} deleted'))
        .catchError((error) {});
  }

  static Future<bool> userExists(String code) async {
    String docId = '';
    final CollectionReference _friendsRef = FirebaseFirestore.instance.collection('folders');
    await _friendsRef
        .where('userId', isEqualTo: code)
        .get()
        .then((QuerySnapshot value) {docId = value.docs.first.id;})
        .catchError((error) {});

    return docId.isNotEmpty;
  }
}
