import 'package:flutter/cupertino.dart';
import 'package:flutter/foundation.dart';
import 'package:flutter/material.dart';
import 'package:json_annotation/json_annotation.dart';
import 'package:uuid/uuid.dart';

part 'friend_model.g.dart';

@immutable
@JsonSerializable(explicitToJson: true, includeIfNull: false)
class FriendModel {

  @JsonKey(name: 'id')
  late final String id;
  @JsonKey(name: 'owningId')
  final String owningId;
  @JsonKey(name: 'friendId')
  final String friendId;
  @JsonKey(name: 'name')
  final String name;


  FriendModel.id(this.owningId, this.friendId, this.name) : id = const Uuid().v1();

  FriendModel(this.id, this.owningId, this.friendId, this.name);

  factory FriendModel.fromJson(Map<String, dynamic> json) => _$FriendModelFromJson(json);
  Map<String, dynamic> toJson() => _$FriendModelToJson(this);
}
