import 'package:cloud_firestore/cloud_firestore.dart';

import 'friend_model.dart';

class FriendModelFirebase {

  static final CollectionReference _friendsRef = FirebaseFirestore.instance.collection('friends');

  static Future<void> storeFriend(FriendModel friend) async {
    String docId = '';
    await _friendsRef
        .where('id', isEqualTo: friend.id)
        .get()
        .then((QuerySnapshot value) {docId = value.docs.first.id;})
        .catchError((error) {});

    if (docId.isEmpty) {
      return _friendsRef
          .add(friend.toJson())
          .then((value) => print('Friend Added'))
          .catchError((error) => print('Failed to add friend: $error'));
    }

    return _friendsRef
        .doc(docId)
        .update(friend.toJson())
        .then((value) => print('Friend ${friend.name} -- $docId updated'))
        .catchError((error) => print('Failed to update friend ${friend.name} -- $docId: $error'));
  }

  static Future<void> deleteItem(FriendModel friend) async {
    String docId = '';
    await _friendsRef
        .where('id', isEqualTo: friend.id)
        .get()
        .then((QuerySnapshot value) {docId = value.docs.first.id;})
        .catchError((error) {});

    return _friendsRef
        .doc(docId)
        .delete()
        .then((value) => print('Friend ${friend.name} -- ${friend.id} deleted'))
        .catchError((error) {});
  }
}
