import 'package:firebase/models/item_model_firebase.dart';
import 'package:flutter/material.dart';
import 'package:json_annotation/json_annotation.dart';
import 'package:uuid/uuid.dart';

import '../item_page.dart';

part 'item_model.g.dart';

@immutable
@JsonSerializable(explicitToJson: true, includeIfNull: false)
class ItemModel {

  @JsonKey(name: 'id')
  final String id;
  @JsonKey(name: 'userId')
  final String userId;
  @JsonKey(name: 'folderId')
  final String folderId;
  @JsonKey(name: 'name')
  final String name;
  @JsonKey(name: 'imageUrl')
  final String imageUrl;
  @JsonKey(name: 'note')
  final String note;


  ItemModel.id(this.userId, this.folderId, this.name, this.imageUrl, this.note) : id = const Uuid().v1();

  ItemModel(this.id, this.userId, this.folderId, this.name, this.imageUrl, this.note);

  factory ItemModel.fromJson(Map<String, dynamic> json) => _$ItemModelFromJson(json);
  Map<String, dynamic> toJson() => _$ItemModelToJson(this);

  void onClickCard(ItemModel item, String userCredential, BuildContext context, bool isEditable) {
    Navigator.of(context).push(
        MaterialPageRoute(
            builder: (_) => ItemPage(
                item: item,
            )
        )
    );
  }

  void onClickDelete() {
    ItemModelFirebase.deleteItem(this);
  }
}
