import 'package:cloud_firestore/cloud_firestore.dart';

import 'item_model.dart';

class ItemModelFirebase {

  static final CollectionReference _itemsRef = FirebaseFirestore.instance.collection('items');

  static Future<void> storeItem(ItemModel item) async {
    String docId = '';
    await _itemsRef
        .where('id', isEqualTo: item.id)
        .get()
        .then((QuerySnapshot value) {docId = value.docs.first.id;})
        .catchError((error) {});

    if (docId.isEmpty) {
      return _itemsRef
          .add(item.toJson())
          .then((value) => print('Item Added'))
          .catchError((error) => print('Failed to add item: $error'));
    }

    return _itemsRef
        .doc(docId)
        .update(item.toJson())
        .then((value) => print('Item ${item.name} -- $docId updated'))
        .catchError((error) => print('Failed to update item ${item.name} -- $docId: $error'));
  }

  static Future<void> deleteItem(ItemModel item) async {
    String docId = '';
    await _itemsRef
        .where('id', isEqualTo: item.id)
        .get()
        .then((QuerySnapshot value) {docId = value.docs.first.id;})
        .catchError((error) {});

    return _itemsRef
        .doc(docId)
        .delete()
        .then((value) => print('Item ${item.name} -- ${item.id} deleted'))
        .catchError((error) {});
  }
}
